import es,gamethread

smoke_duration = es.ServerVar("smoke_duration")
smoke_damage = es.ServerVar("smoke_damage")
smoke_radius = es.ServerVar("smoke_radius")
smoke_damage_enemies_only = es.ServerVar("smoke_damage_enemies_only")

def load():
    es.doblock('corelib/noisy_on')

def weapon_fire(event_var):
    if event_var['weapon'] == 'smokegrenade':
        gamethread.delayed(0.3, modify_smokegrenade, event_var['userid'])

def modify_smokegrenade(str_userid):
    """Modifies the damage and radius properties of any hegrenade belonging to str_userid"""
    dict_entity_list = es.createentitylist('smokegrenade_projectile')
    str_player_handle = es.getplayerhandle(str_userid)
    for int_index in dict_entity_list:
        if str_player_handle == es.getindexprop(int_index, 'CBaseEntity.m_hOwnerEntity'):
            es.setentityname(int_index, "blub")
            es.server.queuecmd("es_fire %s blub ignite" % str_userid)
            return


def grenade_bounce(event_var):
    userid = int(event_var["userid"])
    playerhandle = es.getplayerhandle(userid)
    
    for index in es.createentityindexlist("smokegrenade_projectile"):
        if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == playerhandle:
            es.emitsound('entity', index, 'physics/glass/glass_bottle_break2.wav', 1.0, 0.3)
            coords = es.getindexprop(index ,"CBaseEntity.m_vecOrigin")
            spawn_at_coord(coords,userid)
            
            es.remove(index)
            return
    

def spawn_at_coord(coords,uid):
    index = es.createentity("env_fire","fireee")
    es.entitysetvalue(index, "origin", coords.replace(","," "))
    es.entitysetvalue(index, "health", smoke_duration)
    es.entitysetvalue(index, "firesize", smoke_radius)
    es.entitysetvalue(index, "fireattack", 3)
    es.entitysetvalue(index, "damagescale", smoke_damage)
    es.entitysetvalue(index, "spawnflags", 136)
    # es.entitysetvalue(index, "targetname", "fireee")
    es.spawnentity(index)
    
    es.server.queuecmd("es_fire %s fireee StartFire" % uid)
    
    if smoke_damage_enemies_only:
        handle = es.getplayerhandle(uid)
        es.setindexprop(index, "CBaseEntity.m_hOwnerEntity", handle)
    # es.server.queuecmd("es_fire %s fireee addoutput \"OnUser1 !self,kill,-1,%s\"" % (uid,smoke_duration))
    # es.server.queuecmd("es_fire %s fireee FireUser1" % uid)
    """
    hurter = es.createentity("point_hurt","hindex")
    es.entitysetvalue(hurter, "Damage", smoke_damage)
    es.entitysetvalue(hurter, "DamageRadius", smoke_radius)
    es.entitysetvalue(hurter, "DamageType", 0)
    es.entitysetvalue(hurter, "DamageDelay", 0.5)
    es.entitysetvalue(hurter, "origin", coords.replace(","," "))
    es.entitysetvalue(hurter, "targetname", "hurter")
    es.spawnentity(hurter)
    
    es.server.queuecmd("es_fire %s hurter addoutput \"OnUser1 !self,kill,-1,%s\"" % (uid,smoke_duration))
    es.server.queuecmd("es_fire %s hurter TurnOn" % uid)
    es.server.queuecmd("es_fire %s hurter FireUser1" % uid)
    """
    """
    index = es.createentity("env_shooter","smind")
    es.entitysetvalue(index, "origin", coords.replace(","," "))
    es.entitysetvalue(index, "angels", "-90 0 0")
    es.entitysetvalue(index, "spawnflags", 3)
    es.entitysetvalue(index, "m_iGibs", 5)
    es.entitysetvalue(index, "m_flVelocity", 200)
    es.entitysetvalue(index, "gibgravityscale", 1)
    es.entitysetvalue(index, "simulation", 0)
    es.entitysetvalue(index, "delay", 0)
    es.entitysetvalue(index, "targetname", "shooter")
    es.spawnentity(index)
    
    es.server.queuecmd("es_fire %s shooter shoot" % uid)
    """
    
    
    